unit pohyb;

interface
uses typy,konstant,fronty;

procedure zastav_vse(move: integer); {
                                     pri prepnuti zastavi ty co uz nemaji
                                     najizdet do krizovatky
                                     }
procedure vyhodnot_rychlosti(move: integer); {vyhodnoti prednosti}
procedure posun_vse(prohozeni: boolean); {propocte souradnice na dalsim
                                         snimku}

implementation

procedure posun_vse(prohozeni: boolean);
{projde vsechny f[i] a provede zmenu rychlosti, popripade jed}

    function vzdalenost(car1, car2: PJam): longint;
    var dx,dy: longint;
    begin
       dx:=abs(car1^.act^.x-car2^.act^.x);
       dy:=abs(car1^.act^.y-car2^.act^.y);

       vzdalenost:=round(sqrt(dx*dx+dy*dy));
    end;

    procedure vypni_blikani(i:integer);
    var this: PJam;
    begin
        this:=gs[i];
        while (this<>nil) and (this^.act<>nil) do
        begin
          if ((i=1) and (this^.act^.x>xx[9])) or
             ((i=2) and (this^.act^.y>yy[9])) or
             ((i=3) and (this^.act^.x<xx[1])) or
             ((i=4) and (this^.act^.y<yy[1])) then this^.act^.on:=false;
          this:=this^.next;
        end;
    end;

var i: integer;
    this, last: PJam;
begin

    for i:=1 to 2*smeru do
    begin
       if i<smeru+1 then last:=fs[i]
       else last:=gs[i-smeru];

       if (last<>nil) and (last^.act<>NIL) then
       begin
          last^.act^.jed;
          {vyrazovani z front}
          if i<smeru+1 then
          case last^.act^.odkud of
            1: begin
                 if fs[i]^.act^.x<xx[7]+5 then
                 begin
                    vyrad_z_fronty(1);
                    dec(l[1]);
                 end;
               end;
            2: begin
                 if fs[i]^.act^.y<yy[7]+5 then
                 begin
                   vyrad_z_fronty(2);
                   dec(l[2]);
                 end;
               end;
            3: begin
                 if fs[i]^.act^.x>xx[3]-5 then
                 begin
                    vyrad_z_fronty(3);
                    dec(l[3]);
                 end;
               end;
            4: begin
                 if fs[i]^.act^.y>yy[3]-5 then
                 begin
                    vyrad_z_fronty(4);
                    dec(l[4]);
                 end;
               end;
          end
          else
          begin
             {vyrazeni}
             if (gs[i-smeru]^.act^.x<0) or
                (gs[i-smeru]^.act^.x>640) or
                (gs[i-smeru]^.act^.y<0) or
                (gs[i-smeru]^.act^.y>480) then
                begin
                 last:=gs[i-smeru]^.next;
                 vyrad_uplne(i-smeru);
                end;
             vypni_blikani(i-smeru);
          end;
          {konec vyrazovani}

       end;
       if (last<>nil) and (last^.next<>nil) then  this:=last^.next
       else continue;

       while this<>nil do
       begin
          if vzdalenost(this,last)>80 then
                if this^.act^.rychlost<3 then  inc(this^.act^.rychlost);
          if (vzdalenost(this,last)<=80) and (vzdalenost(this,last)>45) then
                               this^.act^.rychlost:=last^.act^.rychlost+1;
          if (vzdalenost(this,last)<=45) then
                               this^.act^.rychlost:=last^.act^.rychlost;
          if (vzdalenost(this,last)<=40) then
                               this^.act^.rychlost:=last^.act^.rychlost-1;
          if (last=fs[i]) and
             ((this^.act^.x<xx[9]+10) and
             (this^.act^.x>xx[1]-10) and
             (this^.act^.y<yy[9]+10) and
             (this^.act^.y>yy[1]-10)) then
             begin
                if prohozeni or
                   ((move=0) and
                   (i mod 2 = 0)) then this^.act^.rychlost:=0
                else this^.act^.rychlost:=last^.act^.rychlost-1;
                this^.act^.wait:=3;
             end;
          if this^.act^.rychlost<0 then this^.act^.rychlost:=0;
          this^.act^.jed;
          last:=this;
          this:=this^.next;
       end;
    end;
end;


procedure zastav_vse(move: integer);
var i: integer;
begin
   case move of
   1: begin
        if fs[1]^.act^.x<xx[10]-10 then fs[1]^.act^.rychlost:=0;
        if fs[3]^.act^.x>xx[0]+10 then fs[3]^.act^.rychlost:=0;
      end;
  -1: begin
        if fs[2]^.act^.y<yy[10]-10 then fs[2]^.act^.rychlost:=0;
        if fs[4]^.act^.y>yy[0]+10 then fs[4]^.act^.rychlost:=0;
      end;
  end;
end;

procedure vyhodnot_rychlosti(move: integer);
{procedura ktera urci kdo se bude posouvat a kdo ne}
const delka_trasy=20; {kolik snimku je na rychlost=1 skrz krizovatku}

      procedure vyhodnot_licha;
      var i,j: integer;
      begin
        i:=1; j:=3;
        {pokud stoji nastavi se jim minimalni rychlost}
        if fs[i]^.act^.rychlost<=1 then   fs[i]^.act^.rychlost:=2;
        if fs[j]^.act^.rychlost<=1 then   fs[j]^.act^.rychlost:=2;

        if (fs[2]^.act^.y<yy[10]-20)
           and (fs[2]^.act^.y>yy[9]-10) then fs[2]^.act^.rychlost:=0
        else if fs[2]^.act^.y<=yy[9]-10 then fs[2]^.act^.rychlost:=2;
        if (fs[4]^.act^.y>yy[0]+20)
           and (fs[4]^.act^.y<yy[1]+10) then fs[4]^.act^.rychlost:=0
        else if fs[4]^.act^.y<=yy[1]+10 then fs[4]^.act^.rychlost:=2;

        {ta se dal bude upravovat podle toho kam maji namireno}
        if (fs[i]^.act^.x<=xx[9]+delka_trasy) and
           (fs[j]^.act^.x>=xx[1]-delka_trasy) then
          case fs[j]^.act^.kam of
           -1: begin
                 if fs[i]^.act^.kam=1 then
                 begin
                    fs[i]^.act^.rychlost:=0;
                    fs[i]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            0: begin
                 if fs[i]^.act^.kam=1 then
                 begin
                    fs[i]^.act^.rychlost:=0;
                    fs[i]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            1: begin
                 if fs[i]^.act^.kam<1 then
                 begin
                    fs[j]^.act^.rychlost:=0;
                    fs[j]^.act^.wait:=5
                 end;
               end;
          end
        else
        begin
          if fs[i]^.act^.rychlost<3 then inc(fs[i]^.act^.rychlost);
          if fs[j]^.act^.rychlost<3 then inc(fs[j]^.act^.rychlost);
        end;
      end;

      procedure vyhodnot_suda; {musi se predelat konstanty x y}
      var i,j: integer;
      begin
        i:=2; j:=4;
        {pokud stoji nastavi se jim minimalni rychlost}
        if fs[i]^.act^.rychlost<=0 then   fs[i]^.act^.rychlost:=2;
        if fs[j]^.act^.rychlost<=0 then   fs[j]^.act^.rychlost:=2;

        if (fs[1]^.act^.x<xx[10]-20)
           and (fs[1]^.act^.x>xx[9]-10) then fs[1]^.act^.rychlost:=0
        else if fs[1]^.act^.x<=xx[9]-10 then fs[1]^.act^.rychlost:=2;
        if (fs[3]^.act^.x>xx[0]+20)
           and (fs[3]^.act^.x<xx[1]+10) then fs[3]^.act^.rychlost:=0
        else if fs[3]^.act^.x<=xx[1]+10 then fs[3]^.act^.rychlost:=2;

        {ta se dal bude upravovat podle toho kam maji namireno}
        if (fs[i]^.act^.y<=yy[9]+delka_trasy) and
           (fs[j]^.act^.y>=yy[1]-delka_trasy) then
          case fs[j]^.act^.kam of
           -1: begin
                 if fs[i]^.act^.kam=1 then
                 begin
                    fs[i]^.act^.rychlost:=0;
                    fs[i]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            0: begin
                 if fs[i]^.act^.kam=1 then
                 begin
                    fs[i]^.act^.rychlost:=0;
                    fs[i]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            1: begin
                 if fs[i]^.act^.kam<1 then
                 begin
                    fs[j]^.act^.rychlost:=0;
                    fs[j]^.act^.wait:=5
                 end;
               end;
          end
        else
        begin
          if fs[i]^.act^.rychlost<3 then inc(fs[i]^.act^.rychlost);
          if fs[j]^.act^.rychlost<3 then inc(fs[j]^.act^.rychlost);
        end;
      end;

var i:integer;

begin
     {vyhodnoti, ze ktere fronty se auta zacnou pohybovat
      tj. nastavi rychlosti prvnim }
 case move of
  -1: {jedou sudi}
      vyhodnot_suda;
   0: {ridi se prednostma}
      begin
        {tato podminka resi 1,3}
        if fs[1]^.act^.rychlost<3 then inc(fs[1]^.act^.rychlost);
        if fs[3]^.act^.rychlost<3 then inc(fs[3]^.act^.rychlost);

        if (fs[1]^.act^.x<=xx[9]+delka_trasy) and
           (fs[3]^.act^.x>=xx[1]-delka_trasy) then
          case fs[3]^.act^.kam of
           -1: begin
                 if fs[1]^.act^.kam=1 then
                 begin
                    fs[1]^.act^.rychlost:=0;
                    fs[1]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            0: begin
                 if fs[1]^.act^.kam=1 then
                 begin
                    fs[1]^.act^.rychlost:=0;
                    fs[1]^.act^.wait:=5
                 end;
                 {jinak nemusim resit kazdy si jede kam chce}
               end;
            1: begin
                 if fs[1]^.act^.kam<1 then
                 begin
                    fs[3]^.act^.rychlost:=0;
                    fs[3]^.act^.wait:=5
                 end;
               end;
          end;
          {resime fs[2]}
          if (fs[2]^.act^.y<=yy[9]+delka_trasy div 2) then
          begin
             if ((fs[1]<>nil) and (fs[1]^.act<>nil) and
                (fs[1]^.act^.x<=xx[9]+3*delka_trasy)) or
                ((fs[3]<>nil) and (fs[3]^.act<>nil) and
                (fs[3]^.act^.x>=xx[1]-3*delka_trasy)) then
             begin
                fs[2]^.act^.rychlost:=0;
                fs[2]^.act^.wait:=20;
                if (fs[4]^.act^.y>=yy[1]-delka_trasy div 2) then
                begin
                  fs[4]^.act^.rychlost:=0;
                  fs[4]^.act^.wait:=20;
                end;
             end
             else {hlavni je pruchodna}
             begin
                if fs[2]^.act^.rychlost<3 then inc(fs[2]^.act^.rychlost);
                if fs[4]^.act^.rychlost<3 then inc(fs[4]^.act^.rychlost);

                if (fs[4]^.act^.y>=yy[1]-delka_trasy) then
                begin
                  case fs[4]^.act^.kam of
                  -1: begin
                        if fs[2]^.act^.kam=1 then
                        begin
                           fs[2]^.act^.rychlost:=0;
                           fs[2]^.act^.wait:=5
                        end;
                        {jinak nemusim resit kazdy si jede kam chce}
                      end;
                   0: begin
                        if fs[2]^.act^.kam=1 then
                        begin
                           fs[2]^.act^.rychlost:=0;
                           fs[2]^.act^.wait:=5
                        end;
                        {jinak nemusim resit kazdy si jede kam chce}
                      end;
                   1: begin
                        if fs[2]^.act^.kam<1 then
                        begin
                           fs[2]^.act^.rychlost:=0;
                           fs[2]^.act^.wait:=5
                        end;
                      end;
                   end;
                 end;
             end;

             if fs[4]^.act^.y>=yy[1]+13 then
             begin
               fs[4]^.act^.rychlost:=2;
               fs[4]^.act^.wait:=0;
             end;
             if fs[2]^.act^.y<=yy[9]-13 then
             begin
               fs[2]^.act^.rychlost:=2;
               fs[2]^.act^.wait:=0;
             end;
          end;
      end;
   1: {jedou po hlavni}
      vyhodnot_licha;
 end;

 for i:=1 to smeru do
 begin
    if fs[i]^.act^.wait>0 then
    begin
       dec(fs[i]^.act^.wait);
       fs[i]^.act^.rychlost:=0;
    end;
 end;

 for i:=1 to smeru do
 begin
    if (gs[i]<>nil) and (gs[i]^.act<>nil) and (gs[i]^.act^.rychlost<5) then
       inc(gs[i]^.act^.rychlost);
 end;
end;

end.