unit fronty;

interface
uses typy, konstant;

procedure vyrad_z_fronty(fi: integer); {presouva auta za krizovatku}
procedure vyrad_uplne(gi: integer); {rozpousti auta}
procedure urci_pozici(var car: PAuto); {vymysli car^.x, car^.y a zaradi
                                       do fronty i prazdne}

implementation

procedure urci_pozici(var car: PAuto);
{vymysli car^.x, car^.y a zaradi do fronty i prazdne}
const odstup=45;
var i:integer;
begin
 i:=car^.odkud;

 {urci x a y}
 case i of
  1: begin
        car^.x:=maxx;
        car^.y:=yy[3];
        if (fe[i]<>nil) and
           (fe[i]^.act<>nil) and
           (fe[i]^.act^.x>=maxx-odstup) then
           car^.x:=fe[i]^.act^.x+odstup;
     end;
  2: begin
        car^.x:=xx[7];
        car^.y:=maxy;
        if (fe[i]<>nil) and
           (fe[i]^.act<>nil) and
           (fe[i]^.act^.y>=maxy-odstup) then
           car^.y:=fe[i]^.act^.y+odstup;
     end;
  3: begin
        car^.x:=minx;
        car^.y:=yy[7];
        if (fe[i]<>nil) and
           (fe[i]^.act<>nil) and
           (fe[i]^.act^.x<=minx+odstup) then
           car^.x:=fe[i]^.act^.x-odstup;
     end;
  4: begin
        car^.x:=xx[3];
        car^.y:=miny;
        if (fe[i]<>nil) and
           (fe[i]^.act<>nil) and
           (fe[i]^.act^.y<=miny+odstup) then
           car^.y:=fe[i]^.act^.y-odstup;
     end;
  end;

 {zapoji do fronty}
 if fs[i]=nil then
 begin
    new(fs[i]);
    fs[i]^.act:=nil;
    fs[i]^.next:=nil;
    fe[i]:=fs[i];
 end;

 if fs[i]^.act=nil then {fronta je prazdna}
 begin
   fs[i]^.act:=car;
   fs[i]^.next:=nil;
   fe[i]:=fs[i];
 end
 else
 begin
   new(fe[i]^.next);
   if fs[i]=fe[i] then fs[i]^.next:=fe[i]^.next; {ve fronte byl pouze jeden}
   fe[i]:=fe[i]^.next;
   fe[i]^.act:=car;
   fe[i]^.next:=nil;
 end;
 inc(l[i]);
end;


procedure vyrad_z_fronty(fi: integer); {budou ctyri fronty, aby
do sebe nestrkali}
var pom: PJam;
      i: integer;
begin
   i:=(fi+2-fs[fi]^.act^.kam) mod 4;
   if i=0 then i:=4;

   if fs[fi]=nil then exit;

   inc(fs[fi]^.act^.rychlost);
   if gs[i]=nil then
   begin
      new(gs[i]);
      ge[i]:=gs[i];
      gs[i]^.act:=nil;
      gs[i]^.next:=nil;
   end;

   if gs[i]^.act=nil then
   begin
       gs[i]^.act:=fs[fi]^.act;
       ge[i]^.act:=fs[fi]^.act;
       fs[fi]:=fs[fi]^.next;
       gs[i]^.next:=nil;
       ge[i]^.next:=nil;
   end
   else
   begin
       new(pom);
       ge[i]^.next:=pom;
       ge[i]:=ge[i]^.next;
       ge[i]^.act:=fs[fi]^.act;
       if gs[i]^.next=nil then gs[i]^.next:=ge[i];
       fs[fi]:=fs[fi]^.next;
       ge[i]^.next:=nil;
   end;

end;

procedure vyrad_uplne(gi: integer);
var   pom: PJam;
begin
   pom:=gs[gi];
   gs[gi]:=gs[gi]^.next;
   dispose(pom^.act);
   dispose(pom);
end;


end.