uses typy,grafika,konstant,crt,graph,pohyb,fronty;

var  test:             PAuto;     {testovaci}
     move:             integer;   {po ktere silnici se jezdi}
     change_lights:    integer; {po jake dobe se zmeni propustnost}
     new_car:          integer; {po jake dobe se zobrazi dalsi auto}
     last_new,last_change:      longint; {posledni zmena propustnosti v...}
     cas:                       longint; {systemovy cas}
     prohozeni:                 boolean; {prave probihajici zmena semaforu}
     vypnuti:                   boolean; {vypnuti, zapnuti semaforu
                                         uzivatelem}

procedure alloc; { zalozi vse co je treba }
var i:integer;
begin
    randomize;

    for i:=1 to smeru do  {alokace mista na fronty}
    begin
      fs[i]:=nil;
      fe[i]:=nil;
      gs[i]:=nil;
      ge[i]:=nil;
    end;

    move          :=  0;   { propustnost po hlavni }
    change_lights :=  delka_cyklu;  { zmena svetel po 400cas }
    new_car       :=  0;   { na zacatku pridame auto a ...}
    last_change   :=  0;   { zacatek cyklu semaforu }
    cas           :=  0;   { "cas" behu - krokovani dle tohoto }
    vypnuti       :=  false; { zda se mohou semafory zapnout}

    if not inicial then exit;
    power_off;
end;

procedure dealloc; {zrusi vsechno co bylo vyrobeno}
var i: integer;
    last,this: PJam;
begin
    for i:=1 to 2*smeru do
    begin
       if i<smeru+1 then last:=fs[i]
       else last:=gs[i-smeru];

       if last<>nil then
       begin
         this:=last^.next;
         if last^.act<>nil then dispose(last^.act);
         dispose(last);
         while this<>nil do
         begin
            last:=this;
            if last^.act<>nil then dispose(last^.act);
            this:=this^.next;
            dispose(last);
         end;
       end;
    end;
    CloseGraph;
end;

procedure pridej_auto(ch: char); {vyrobi nove auticko ve
                                  smeru ch nebo nahodne}
var buggati: PAuto;
begin
    new(buggati);         {vytvori misto}
    buggati^.vytvor(ch);  {urci pocatecni cisla auta}
    urci_pozici(buggati); {urci pozici a priradi do fronty}
    buggati^.zobraz;      {zobrazi na obrazovce}
end;

function next_change: integer; {dalsi zmena na semaforech nastane za ...}
var max_even,max_odd,pom: integer;
begin
   if l[4]>l[2] then max_even:=l[4]
   else max_even:=l[2];
   if l[3]>l[1] then max_odd:=l[3]
   else max_odd:=l[1];

   if (max_odd+max_even>0) then pom:=round(delka_cyklu/(max_odd+max_even))
   else pom:=delka_cyklu;
   if move=1 then  next_change:=pom*max_odd;
   if move=-1 then next_change:=pom*max_even;
   if move=0 then next_change:=delka_cyklu;
   if max_odd+max_even>9 then next_change:=delka_cyklu div 2;

end;

procedure prohod; { zmnena na semaforech }
var max_even,max_odd: integer;
begin
   if l[4]>l[2] then max_even:=l[4]
   else max_even:=l[2];
   if l[3]>l[1] then max_odd:=l[3]
   else max_odd:=l[1];

   case move of
      0: move:=1;
      1: move:=-1;
     -1: move:=1;
   end;
   if (max_odd+max_even<4) then move:=0;
end;

procedure zmen_sem;  { postupne bude nastavovat na semaforech spravne barvy }
var p: integer;
begin
  if cas-last_change<30 then p:=2;
  if cas-last_change=30 then
  begin
     p:=3;
     prohozeni:=false;
  end;

  case move of
    1: begin
          set_sem(1,p);
          set_sem(3,p);
          p:=(p+2) mod 4;
          if p=0 then p:=4;
          set_sem(2,p);
          set_sem(4,p);
       end;
   -1: begin
          set_sem(2,p);
          set_sem(4,p);
          p:=(p+2) mod 4;
          if p=0 then p:=4;
          set_sem(1,p);
          set_sem(3,p);
       end;
   end;
end;

var i: integer;
   ch: char;
begin
  alloc;
  while ch<>'q' do
  begin
    while not KeyPressed do
    begin
       inc(cas); {cas je stale zvysovan}

       if prohozeni and (cas-last_change<31) then zmen_sem;

       if move=0 then
       begin
          if (cas mod 30 < 15) then orange(true)
          else orange(false);
       end;

       if ( cas - new_car ) > last_new then {podle casu pridava auta}
       begin
          pridej_auto(ch);
          new_car:=cas;
          last_new:=random(40)+15;
       end;

       vykresli_vse(true);
       delky_front(true);

       {pozastaveni behu}
       if ch='p' then
       begin
          ch:='a';
          while (ch<>'p') and (ch<>'q') do ch:=ReadKey;
          if (ch<>'q') then ch:='a'
          else break;
       end;

       delay(30);
       vykresli_vse(false);
       delky_front(false);

       {prepni semafor je-li uz cas}
       if not vypnuti and
          ((change_lights<cas-last_change) or
          (ch='+')) then
       begin
          ch:='a';
          prohozeni:=true;
          last_change:=cas;
          prohod;
          change_lights:=next_change;
       end;

       if (vypnuti) and (move<>0) then
       begin
          move:=0;
          prohozeni:=true;
       end;

       vyhodnot_rychlosti(move);
       if prohozeni then zastav_vse(move);

       posun_vse(prohozeni);

    end;

    {ovladani}
    if (ch<>'q') then ch:=ReadKey;
    if (ch>='1') and (ch<='4') then
    begin
       pridej_auto(ch);
       ch:='a';
    end;
    if (ch='v') then
    begin
       vypnuti:=not vypnuti;
       ch:='a';
       if vypnuti then SetColor(4)
       else SetColor(0);
       OutTextXY(450,80,'VYPNUTO');
    end;

  end;
  dealloc;
end.