unit typy;

interface
uses konstant,graph;

type PAuto=^TAuto;
     TAuto=object

     odkud,kam:integer;{
                        odkud kam jede auto - odkud cislovano jako hodiny
                        tedy 1,2,3,4
                        kam cislovano - 0 rovne, 1 vpravo, -1 vlevo
                        }
     color: word;      {barva auta}
     x,y: integer; {pozice auta}
     deg: real; {otceni - cislovano jako odkud ve stupnich}
     rychlost: integer; {pixelu za snimek}
     wait: integer; {cekaci doba po tom co muze jet}
     on: boolean; {zda blika ci jiz ne}

     constructor Vytvor(ch: char);
     procedure Jed; {urci nasledujici pozici auta}
     procedure Zobraz; {vykresli auto}
     procedure Smaz;  {smaze auto}

end;

type PJam=^TJam;
     TJam=record
     act:  PAuto;
     next: PJam;
end;

var  fs, fe: array [1..smeru] of PJam; {auta co jedou do krizovatky}
     l: array [1..smeru] of integer;   {pocet aut ve fronte}
     gs, ge: array [1..smeru] of PJam; {auta co vyjeli z krizovatky}
     move: integer;


implementation

constructor TAuto.Vytvor(ch: char);
begin
     odkud:=random(4)+1;
     case ch of
        '1': odkud:=1;
        '2': odkud:=2;
        '3': odkud:=3;
        '4': odkud:=4;
     end;
     deg:=90*(odkud-1);

     kam:=random(3)-1;
     color:=random(15)+1;
     rychlost:=random(4)+2;
     wait:=0;
     on:=true;
end;

procedure TAuto.Jed; {propocte dalsi zobrazeni auta}
begin
 if rychlost = 0 then exit;
 case odkud of
  1: begin
     case kam of
       -1: begin
            if x>=xx[9] then x:=x-rychlost;
            if (x<xx[9]) and (x>=xx[8]) then
            begin
              x:=x-rychlost;
              y:=round(sqrt(75*75-(x-xx[9])*(x-xx[9]))+yy[1]);
              {uhel}
              if y<>yy[1] then
                deg:=arctan((xx[9]-x)/(y-yy[1]))*360/2/Pi
              else
                deg:=90;
            end;
            if (x<xx[8]) and (x>xx[7]) then
            begin
              y:=y-rychlost;
              x:=round(-sqrt(75*75-(y-yy[1])*(y-yy[1]))+xx[9]);
              {uhel}
              if y<>yy[1] then
                deg:=arctan((xx[9]-x)/(y-yy[1]))*360/2/Pi
              else
                deg:=90;
            end;
            if (x<=xx[7]) then
            begin
              y:=y-rychlost;
              deg:=90;
            end;
          end;
      0: begin
            x:=x-rychlost;
         end;
      1: begin
          if x>=xx[9] then x:=x-rychlost;
          if (x<xx[9]) and (x>=xx[6]) then
          begin
            x:=x-rychlost;
            y:=round(-sqrt(175*175-(x-xx[10])*(x-xx[10]))+yy[10]);
            if y<>yy[10] then
               deg:=360+arctan((xx[10]-x)/(y-yy[10]))*360/2/Pi
            else y:=270;
          end;
          if (x<xx[6]) and (x>xx[3]) then
          begin
            y:=y+rychlost;
            x:=round(-sqrt(175*175-(y-yy[10])*(y-yy[10]))+xx[10]);
            if y<>yy[10] then
               deg:=360+arctan((xx[10]-x)/(y-yy[10]))*360/2/Pi
            else y:=270;
          end;
          if (x<=xx[3]) then
          begin
             y:=y+rychlost;
             deg:=270;
          end;
         end;
       end;
     end;
  2: begin
       case kam of
        -1: begin
              if y>=yy[9] then y:=y-rychlost;
              if (y<yy[9]) and (y>=yy[8]) then
              begin
                y:=y-rychlost;
                x:=round(-sqrt(75*75-(y-yy[9])*(y-yy[9]))+xx[9]);
                if y<>yy[9] then
                  deg:=180+arctan((xx[9]-x)/(y-yy[9]))*360/2/Pi
                else deg:=180;
              end;
              if (y<yy[8]) and (y>yy[7]) then
              begin
                x:=x+rychlost;
                y:=round(-sqrt(75*75-(x-xx[9])*(x-xx[9]))+yy[9]);
                if y<>yy[9] then
                  deg:=180+arctan((xx[9]-x)/(y-yy[9]))*360/2/Pi
                else deg:=180;
              end;
              if (y<=yy[7]) then
              begin
                 x:=x+rychlost;
                 deg:=180;
              end;
            end;
         0: begin
              y:=y-rychlost;
            end;
         1: begin
             if y>=yy[9] then y:=y-rychlost;
             if (y<yy[9]) and (y>=yy[6]) then
             begin
              y:=y-rychlost;
              x:=round(sqrt(175*175-(y-yy[10])*(y-yy[10]))+xx[0]);
              if y<>yy[0] then
                deg:=90-arctan((xx[10]-x)/(y-yy[0]))*360/2/Pi
              else deg:=0;
             end;
             if (y<yy[6]) and (y>yy[3]) then
             begin
               x:=x-rychlost;
               y:=round(-sqrt(175*175-(x-xx[0])*(x-xx[0]))+yy[10]);
               if y<>yy[0] then
                 deg:=90-arctan((xx[10]-x)/(y-yy[0]))*360/2/Pi
               else deg:=0;
             end;
             if (y<=yy[3]) then
             begin
                x:=x-rychlost;
                deg:=0;
             end;
            end;
       end;
     end;
  3: begin
       case kam of
        -1: begin
              if x<=xx[1] then x:=x+rychlost;
              if (x>=xx[1]) and (x<=xx[2]) then
              begin
                x:=x+rychlost;
                y:=round(-sqrt(75*75-(x-xx[1])*(x-xx[1]))+yy[9]);
                if y<>yy[9] then
                  deg:=180+arctan((xx[1]-x)/(y-yy[9]))*360/2/Pi
                else deg:=270;
              end;
              if (x>xx[2]) and (x<xx[3]) then
              begin
                y:=y+rychlost;
                x:=round(sqrt(75*75-(y-yy[9])*(y-yy[9]))+xx[1]);
                if y<>yy[9] then
                  deg:=180+arctan((xx[1]-x)/(y-yy[9]))*360/2/Pi
                else deg:=270;
              end;
              if (x>=xx[3]) then
              begin
                y:=y+rychlost;
                deg:=270;
              end;
            end;
         0: begin
              x:=x+rychlost;
            end;
         1: begin
             if x<=xx[1] then x:=x+rychlost;
             if (x>xx[1]) and (x<=xx[4]) then
             begin
              x:=x+rychlost;
              y:=round(sqrt(175*175-(x-xx[0])*(x-xx[0]))+yy[0]);
              if y<>yy[0] then
                deg:=180+arctan((xx[0]-x)/(y-yy[0]))*360/2/Pi
              else deg:=90;
             end;
             if (x>xx[4]) and (x<xx[7]) then
             begin
               y:=y-rychlost;
               x:=round(sqrt(175*175-(y-yy[0])*(y-yy[0]))+xx[0]);
               if y<>yy[0] then
                 deg:=180+arctan((xx[0]-x)/(y-yy[0]))*360/2/Pi
               else deg:=90;
             end;
             if (x>=xx[7]) then
             begin
                y:=y-rychlost;
                deg:=90;
             end;
            end;
       end;
     end;
  4: begin
       case kam of
        -1: begin
              if y<=yy[1] then y:=y+rychlost;
              if (y>yy[1]) and (y<=yy[2]) then
              begin
                y:=y+rychlost;
                x:=round(sqrt(75*75-(y-yy[1])*(y-yy[1]))+xx[1]);
                if y<>yy[1] then
                  deg:=arctan((xx[1]-x)/(y-yy[1]))*360/2/Pi
                else deg:=360;
              end;
              if (y>yy[2]) and (y<yy[3]) then
              begin
                x:=x-rychlost;
                y:=round(sqrt(75*75-(x-xx[1])*(x-xx[1]))+yy[1]);
                if y<>yy[1] then
                  deg:=arctan((xx[1]-x)/(y-yy[1]))*360/2/Pi
                else deg:=360;
              end;
              if (y>=yy[3]) then
              begin
                 x:=x-rychlost;
                 deg:=360;
              end;
            end;
         0: begin
              y:=y+rychlost;
            end;
         1: begin
             if y<=yy[1] then y:=y+rychlost;
             if (y>yy[1]) and (y<=yy[4]) then
             begin
              y:=y+rychlost;
              x:=round(-sqrt(175*175-(y-yy[0])*(y-yy[0]))+xx[10]);
              if y<>yy[0] then
                deg:=180+arctan((xx[10]-x)/(y-yy[0]))*360/2/Pi
              else deg:=180;
             end;
             if (y>yy[4]) and (y<yy[7]) then
             begin
               x:=x+rychlost;
               y:=round(sqrt(175*175-(x-xx[10])*(x-xx[10]))+yy[0]);
               if y<>yy[0] then
                 deg:=180+arctan((xx[10]-x)/(y-yy[0]))*360/2/Pi
               else deg:=180;
             end;
             if (y>=yy[7]) then
             begin
               x:=x+rychlost;
               deg:=180;
             end;
            end;
        end;
       end;
  end;
end;

procedure TAuto.Zobraz;
var k,l,r: integer;
    rad: real;
    p,x0,y0,x1,x2,y1,y2: longint;
begin
  if (x>0) and (x<640) and (y>0) and (y<480) then
  begin
     p:=7;
     k:=12;
     l:=9;

     SetColor(grey);

     r:=15;

     rad:=Pi*(deg+36.8699)/180;
     y1:=round( sin(rad)*r );
     x1:=round( cos(rad)*r );

     rad:=rad-1.287002;
     y2:=round( sin(rad)*r );
     x2:=round( cos(rad)*r );

     {ram}
     line(x+x1,y+y1,x+x2,y+y2);
     line(x+x2,y+y2,x-x1,y-y1);
     line(x-x1,y-y1,x-x2,y-y2);
     line(x-x2,y-y2,x+x1,y+y1);

     {strecha}
     SetColor(color);
     SetFillPattern(full,color);
     FloodFill(x,y,grey);

     SetColor(grey);
     {svetla}
     if on then
     begin
        if kam=-1 then
        begin
           SetFillPattern(full,6);
           PieSlice(x-x1,y-y1,0,360,2);
           PieSlice(x+x2,y+y2,0,360,2);
        end;
        if kam=+1 then
        begin
           SetFillPattern(full,6);
           PieSlice(x+x1,y+y1,0,360,2);
           PieSlice(x-x2,y-y2,0,360,2);
        end;
     end;
  end;
end;

procedure TAuto.Smaz;
begin
     SetFillPattern(full,0);
     SetColor(0);
     if (x>=0) and (x<=640) and (y>=0) and (y<480) then
     PieSlice(x,y,0,360,18);
end;


end.